##
##
##
##

## Open Source File ## 
($file_in = shift @ARGV) or die "usage: perl assembler.pl file_in.s\n";
if($file_in =~ /^(.+)\.s$/)
{
  $file_out = $1 . ".out";
}
else
{
  $file_out = $file_in . ".out";
}

open(IN,  $file_in ) or die "File $file_in not found.\n";
open(OUT, ">$file_out") or die "Cannot open $file_out\n";

$cnt = 1;			#s

## Scan all lines to make list of label at first ##
while($line = <IN>)
{
  chomp $line;
  
  if($line =~ /^\s*\./)			#'.'Ŏn܂s͖
  {
    next;
  }
  
  if($line =~ /([\w\.]+)\s*:\s*(\#.*)?$/)		#':'ŏIs̓x
  {
    push @lbl_tmp, $1;
    next;
  }
  
  if($line =~ /^\s*(\#.*)?$/)		#s܂̓Rĝ
  {
    next;
  }
  
  if($line =~ /^\s*0x([0-9a-fA-F]+)\s*(\#.*)?$/)	#0x... ̌`ǂ
  {
    $val = hex($1);
  }
  else
  {
    $val = $cnt;		#łȂ΍s
    $cnt++;
  }
  if(@lbl_tmp)
  {
    while($lbl = shift @lbl_tmp)
    {
      $lbl_lst{$lbl} = $val;
    }
  }
}

seek(IN, 0, 0);			#擪ɖ߂
$cnt = 1;

############   ߃Zbg̒萔   ###################

## ALU operations ##########
$op_def{"add"} = 0x0;
$op_def{"sub"} = 0x0;
$op_def{"mul"} = 0x0;
$op_def{"div"} = 0x0;
$op_def{"sll"} = 0x0;
$op_def{"srl"} = 0x0;
$op_def{"srr"} = 0x0;
$op_def{"and"} = 0x0;
$op_def{"or" } = 0x0;
$op_def{"xor"} = 0x0;
$op_def{"not"} = 0x0;
$fnct_def{"add"} = 0x0;
$fnct_def{"sub"} = 0x4;
$fnct_def{"mul"} = 0x8;
$fnct_def{"div"} = 0x10;
$fnct_def{"sll"} = 0x18;
$fnct_def{"srl"} = 0x1C;
$fnct_def{"srr"} = 0x1D;
$fnct_def{"and"} = 0x20;
$fnct_def{"or" } = 0x24;
$fnct_def{"xor"} = 0x28;
$fnct_def{"not"} = 0x2C;

## ALU operations with immediate #######
$op_def{"addi"} = 0x18;
$op_def{"subi"} = 0x19;
$op_def{"muli"} = 0x1A;
$op_def{"divi"} = 0x1C;
$op_def{"andi"} = 0x1D;
$op_def{"ori" } = 0x1E;
$op_def{"xori"} = 0x1F;

## FPU operations ###############
$op_def{"fadd" } = 0x1;
$op_def{"fsub" } = 0x1;
$op_def{"fmul" } = 0x1;
$op_def{"fdiv" } = 0x1;
$op_def{"itof" } = 0x1;
$op_def{"ftoi" } = 0x1;
$op_def{"fabs" } = 0x1;
$op_def{"fneg" } = 0x1;
$op_def{"floor"} = 0x1;
$op_def{"fsqrt"} = 0x1;
$fnct_def{"fadd" } = 0x0;
$fnct_def{"fsub" } = 0x1;
$fnct_def{"fmul" } = 0x2;
$fnct_def{"fdiv" } = 0x4;
$fnct_def{"itof" } = 0x8;
$fnct_def{"ftoi" } = 0x9;
$fnct_def{"fabs" } = 0x3;
$fnct_def{"fneg" } = 0x6;
$fnct_def{"floor"} = 0x1C;
$fnct_def{"fsqrt"} = 0x1E;

$op_def{"sin"}  = 0x1;
$op_def{"cos"}  = 0x1;
$op_def{"atan"} = 0x1;
$fnct_def{"sin"}  = 0x10;
$fnct_def{"cos"}  = 0x11;
$fnct_def{"atan"} = 0x12;

## System operations ###########
$op_def{"nop"} = 0x2;
$op_def{"hlt"} = 0x2;
$op_def{"rd" } = 0x2;
$op_def{"wr" } = 0x2;
$fnct_def{"nop"} = 0x0;
$fnct_def{"hlt"} = 0x2;
$fnct_def{"rd" } = 0x4;
$fnct_def{"wr" } = 0x5;

$op_def{"frd" } = 0x2;
$fnct_def{"frd" } = 0x6;
$op_def{"br" } = 0x2;
$fnct_def{"br" } = 0x7;

## Memory operations ##########
$op_def{"load" } = 0x10;
$op_def{"store"} = 0x12;

## Jump operations ##########
$op_def{"jump"} = 0x4;
$op_def{"jal" } = 0x5;
$op_def{"jr"  } = 0x8;

## Conditional branch operations #####
$op_def{"bl"  } = 0x21;
$op_def{"be"  } = 0x22;
$op_def{"ble" } = 0x23;
$op_def{"bge" } = 0x25;
$op_def{"bne" } = 0x26;
$op_def{"bg"  } = 0x27;
$op_def{"blz" } = 0x29;
$op_def{"bez" } = 0x2A;
$op_def{"blez"} = 0x2B;
$op_def{"bgez"} = 0x2D;
$op_def{"bnez"} = 0x2E;
$op_def{"bgz" } = 0x2F;

$op_def{"fbl"  } = 0x31;
$op_def{"fbe"  } = 0x32;
$op_def{"fble" } = 0x33;
$op_def{"fbge" } = 0x35;
$op_def{"fbne" } = 0x36;
$op_def{"fbg"  } = 0x37;
$op_def{"fblz" } = 0x39;
$op_def{"fbez" } = 0x3A;
$op_def{"fblez"} = 0x3B;
$op_def{"fbgez"} = 0x3D;
$op_def{"fbnez"} = 0x3E;
$op_def{"fbgz" } = 0x3F;

######################################

while($line = <IN>)
{
  chomp $line;
  
  if($line =~ /^\s*\./)			#'.'Ŏn܂s͖
  {
    next;
  }
  
  if($line =~ /:\s*(\#.*)?$/)		#':'ŏIs̓x
  {
    next;
  }
  
  if($line =~ /^\s*(\#.*)?$/)		#s܂̓Rĝ
  {
    next;
  }
  
  if($line =~ /^\s*0x([0-9a-fA-F]+)\s*(\#.*)?$/)		#0x... ̌`ǂ
  {
    next;
  }
  
  if($line =~ /^\s*(\S+)(\s+(\S+)(\s+(\S+)(\s+(\S+))?)?)?\s*(\#.*)?$/)
  {
    $op = $1;
    $t1 = $3;
    $t2 = $5;
    $t3 = $7;
    
    if($t1 =~ /^r(\d+)$/)
    {
      $r1 = $1 & 0x1F;			#WX^ԍ
    }
    if($t2 =~ /^r(\d+)$/)
    {
      $r2 = $1 & 0x1F;
    }
    if($t3 =~ /^r(\d+)$/)
    {
      $r3 = $1 & 0x1F;
    }
    
    if($t1 =~ /^(-?(\d+))$/)
    {
      $tgt = $1 & 0x3FFFFFF;				#J`26bit΃AhX(10i)
    }
    elsif($t1 =~ /^0x([0-9a-fA-F]+)$/)
    {
      $tgt = hex($1) & 0x3FFFFFF;			#16i΃AhX
    }
    elsif($t1 =~ /^([\w\.]+)$/)
    {
      $tgt = ($lbl_lst{$1} - $cnt) & 0x3FFFFFF;		#xɂ鑊΃AhX
    }
    
    if($t3 =~ /^(-?(\d+))$/)
    {
      $imm = $1 & 0xFFFF;				#I`16bitl(10i)
    }
    elsif($t3 =~ /^0x([0-9a-fA-F]+)$/)
    {
      $imm = hex($1) & 0xFFFF;				#16i
    }
    elsif($t3 =~ /^hi\(([\w\.]+)\)$/)
    {
      $imm = ($lbl_lst{$1} & 0xFFFF0000) >> 16;		#x̒l̏ʃrbg
    }
    elsif($t3 =~ /^lo\(([\w\.]+)\)$/)
    {
      $imm = $lbl_lst{$1} & 0xFFFF;			#ʃrbg
    }
    elsif($t3 =~ /^([\w\.]+)$/)
    {
      $imm = ($lbl_lst{$1} - $cnt) & 0xFFFF;		#x̒l
    }
#
#
#addi r3 r0 hi(abc.1)
#sll r3 r3 16
#addi r3 r0 lo(abc.1)
#jr r3
#ɂĂ͑l̓x̎w΃AhXKp
#
#bl r3 r4 abc.1
#ɂĂ͑l݂͌PCɑ΂ăx̎w΃AhXKp
#

    if($op =~ /^(add|sub|mul|div|and|or|xor|fadd|fsub|fmul|fdiv)$/)
    {
      # R`(3)
      $val =  $op_def{$op} << 26 | $r2 << 21 | $r3 << 16 | $r1 << 11 | $fnct_def{$op};
    }
    elsif($op =~ /^(not|itof|ftoi|fabs|fneg|floor|fsqrt)$/)
    {
      # R`(2)
      $val = $op_def{$op} << 26 | $r2 << 21 | $r1 << 11 | $fnct_def{$op};
    }
    elsif($op =~ /^(sll|srl|srr)$/)
    {
      # R`(Vtg)
      $val = $op_def{$op} << 26 | $r2 << 21 | $r1 << 11 | ($imm & 0x1F) << 6 | $fnct_def{$op};
    }
    elsif($op =~ /^(addi|subi|muli|divi|andi|ori|xori|load|store)$/)
    {
      # I`(lу)
      $val = $op_def{$op} << 26 | $r2 << 21 | $r1 << 16 | $imm;
    }
    elsif($op =~ /^f?b(l|e|le|ge|ne|g)z?$/)
    {
      # I`()
      $val = $op_def{$op} << 26 | $r1 << 21 | $r2 << 16 | $imm;
    }
    elsif($op =~ /^(jump|jal)$/)
    {
      # J`
      $val = $op_def{$op} << 26 | $tgt;
    }
    elsif($op eq "jr")
    {
      $val = $op_def{$op} << 26 | $r1 << 21;
    }
    elsif($op =~ /^f?rd$/)
    {
      #R`(Ǎ)
      $val = $op_def{$op} << 26 | $r1 << 11 | $fnct_def{$op};
    }
    elsif($op eq "wr")
    {
      #R`()
      $val = $op_def{$op} << 26 | $r1 << 21 | $fnct_def{$op};
    }
    elsif($op eq "br")
    {
      #u[N|Cg
      $val = $op_def{$op} << 26 | ($tgt & 0x1F) << 21 | $fnct_def{$op};
    }
    elsif($op =~ /^(nop|hlt)$/)
    {
      # NOP or HLT
      $val = $op_def{$op} << 26 | $fnct_def{$op};
    }
  }else{
    die "Syntax error at line : $cnt\n";
  }
  
  #printf OUT "0x%08X\n", $val;
  printf OUT "0x%08X\t$op $t1 $t2 $t3\n", $val;	#fobOp
  
  $cnt++;
}

close(IN);
close(OUT);
